Subject: RE: [rohc] Failure in Copy-offset torture test.

From: "West, Mark" <[email-masked]>
Date: Fri, 10 Dec 2004 18:10:20 -0000

Chitrak,

There is nothing wrong with the torture test (not that it couldn't be
'improved' -- see below, but as it is, it works fine).

I haven't run Anders code from Ethereal for SigComp, but at a cursory glance
looks correct.  Are you looking at the result of the 'OUTPUT' instruction?
(rather than just the contents of VM memory)

This is important because arguably this is as much a test of OUTPUT as of
COPY-OFFSET: the repeated string of bytes comes from the OUTPUT honouring
byte_copy_left/_right and delivering bytes 66 onwards twice!

Which leads to an interesting observation... despite being billed as a
'COPY-OFFSET' torture-test, if COPY-OFFSET is implemented correctly it
actually has *no* impact on the output of the test (except, pedantically, on
the cycle count!)

After the first COPY-LITERAL, the 'destination' never encounters
byte_copy_right (it is either too far away, at 0x4040, or below the current
value -- destination is 97 after the first COPY; byte_copy_right is reset to
74, later).  Thus the results of the subsequent COPY-OFFSETs (including a
very large offset and presumably with some expectation of testing the
wrapping/indexing) do not appear in the string that is OUTPUT!  The 0x40's
come from the first COPY-LITERAL, the other bytes from the update of
destination (which only proves that the right number of bytes have been
copied) and explicit loads and the repeat of these during the OUTPUT.

It might, in reissuing this document (which I believe we've agreed to do),
be prudent to tighten this test up a bit!  It might be nice, after all, if
it really *did* test COPY-OFFSET...

Cheers,

Mark.

> -----Original Message-----
> From: chitrak gupta [mailto:[email-masked]]
> Sent: 10 December 2004 13:12
> To: [email-masked]
> Subject: [rohc] Failure in Copy-offset torture test.
> 
> 
> Dear All,
> 
> After trying for the last 2 weeks to pass the torture test for
> copy-offset I started searching for answers when I landed upon a UDVM
> implementation by Anders Broman [email-masked].  I ran and
> compiled the code along with the torture test bytecode. What I got
> from the code is this:
> 
> 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 
> 
> 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40 40
> 
> 00 42 00 4a 40 74 40 40 40 40 40 40 40 40 40 40
> 
>  
> 
> But the result given in the torture test is this 
> 
> The expected output of the code is 32 instances of 0x40 followed by 
> 0x0042 004a 0074 4040 4040 004a 0074 4040.
> 
> So can anyone please clarify if the result in the torture test
> document is valid or if there is an error in my interpretation. Is
> there any flaw in the source code I got?
> 
> Waiting for a response,
> 
> Thanks in advance.
> 
> Chitrak
> 
> _______________________________________________
> Rohc mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/rohc
> 

_______________________________________________
Rohc mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/rohc

---

From: "Basudeb Gupta" <[email-masked]>
Date: Sat, 11 Dec 2004 12:01:31 +0530

Hi Mark,

Being a member of the same team as chitrak's I need a little help from you. 
I have a few doubts that are:

a) Does the Deflate byte code given in the user guide  correspond to the 
zlib Deflate compression algorithm? I say so because although I am able to 
deflate a compressed string as small as "Hi how are you?" which does not use 
COPY-OFFSET, a longer string invariably returns junk after decompression.

Is there a DEFLATE compression algorithm and Bytecode pair, that we can use 
to test our UDVM?

At least for the LZSS I have reasonable doubt that it is something different 
from the LZSS in the zlib.

2)  Is there a DEFALGE compression algorith and bytecode pair with static 
dictionary implementation that we can use to test our UDVM?

An early reply will be greatly appreciated, as we are in a delivery 
situation and the project is in a decisive stage.

Thanks in advance
Basudeb

>From: "West, Mark" <[email-masked]>
>To: "'chitrak gupta'" <[email-masked]>, [email-masked]
>Subject: RE: [rohc] Failure in Copy-offset torture test.
>Date: Fri, 10 Dec 2004 18:10:20 -0000
>
>
>Chitrak,
>

_________________________________________________________________
Pep up your screen! Kickstart your day! 
http://www.msn.co.in/Cinema/screensaver/ Get these vibrant screensavers!